---@type pd_graphics_lib
local gfx <const> = playdate.graphics

local ThrowMeterHeight <const> = 50
local ThrowMeterLingerSec <const> = 1.5

---@param x number
---@param y number
function throwMeter:draw(x, y)
    gfx.setLineWidth(1)
    gfx.drawRect(x, y, 14, ThrowMeterHeight)
    if self.lastReadThrow then
        -- TODO: If ratio is "perfect", show some additional effect
        -- TODO: If meter has moved to a new fielder, empty it.
        local ratio = (self.lastReadThrow - throwMeter.MinCharge) / (self.idealPower - throwMeter.MinCharge)
        local height = ThrowMeterHeight * ratio
        gfx.fillRect(x + 2, y + ThrowMeterHeight - height, 10, height)
    end
    -- TODO: Dither or bend if the user throws too hard
    -- Or maybe dither if it's too soft - bend if it's too hard
end

function throwMeter:drawNearFielder(fielder)
    if not fielder and not self.lastThrower then
        return
    end
    if fielder then
        self.lastThrower = fielder
        actionQueue:upsert("throwMeterLinger", 200 + ThrowMeterLingerSec * 1000, function()
            local dt = 0
            while dt < ThrowMeterLingerSec do
                dt = dt + coroutine.yield()
            end
            self.lastThrower = nil
        end)
    end
    self:draw(self.lastThrower.x - 25, self.lastThrower.y - 10)
end
